package com.ilstechnology.androidkitilsv2;

import android.content.Context;
import android.os.AsyncTask;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.content.Intent;
import android.app.Activity;
import android.widget.EditText;
import android.widget.Switch;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;
import android.view.Window;

public class Main extends Activity {

    Context c;
    String response_;
    EditText email, password;
    String er;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);
        final JSONParser jSon = new JSONParser();

        email = (EditText) findViewById(R.id.emailText);
        password = (EditText) findViewById(R.id.passwordText);

        OnClickListener listnr=new OnClickListener() {
            @Override
            public void onClick(View v) {


                final String email_ = email.getText()+"";
                final String password_ = password.getText()+"";

                if(email.length() == 0 || password.length() == 0){
                    Toast.makeText(getApplicationContext(),"Please fill username and password", Toast.LENGTH_SHORT).show();
                    return;
                }else{
                    new Thread(new Runnable() {
                        public void run() {
                            //ApiCall
                            String json_ = "{\"auth\": {\"command\": \"api.authenticate\", \"params\": {\"password\": \""+password_+"\", \"username\": \""+email_+"\"}}}";
                            response_ = jSon.xHttpPost("http://api.devicewise.com/api", json_);

                            try {
                                System.out.println("Response: "+response_);
                                JSONObject jsonObj = new JSONObject(response_);
                                //Response
                                if(jsonObj.has("auth")){
                                    JSONObject auth = jsonObj.getJSONObject("auth");
                                    boolean success = auth.getBoolean("success");
                                    if (success) {
                                        JSONObject params = auth.getJSONObject("params");
                                        Global.sessionId = params.getString("sessionId");
                                        Global.prevOrg = params.getString("orgKey");
                                        personaldata();
                                        Intent i = new Intent(Main.this, organizations.class);
                                        startActivity(i);
                                        ((EditText) findViewById(R.id.emailText)).getText().clear();
                                        ((EditText) findViewById(R.id.passwordText)).getText().clear();
                                    }
                                }else{

                                    JSONArray error = jsonObj.getJSONArray("errorMessages");
                                    er = error.get(0).toString();
                                    runOnUiThread(new Runnable() {
                                        public void run() {
                                            Toast.makeText(getApplicationContext(), er, Toast.LENGTH_SHORT).show();
                                        }
                                    });

                                }


                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    }).start();

                }

            }
        };
        Button signIn =(Button) findViewById(R.id.signIn);
        signIn.setOnClickListener(listnr);

    }

    private void personaldata(){
        try{
            final JSONParser jSon = new JSONParser();
            String json_ = "{\"auth\":{\"sessionId\":\"" + Global.sessionId + "\"},\"cmd\":{\"command\":\"user.find\",\"params\":{\"emailAddress\":\"" + email.getText() + "\"}}}";
            response_ = jSon.xHttpPost("http://api.devicewise.com/api", json_);
            JSONObject jsonObj = new JSONObject(response_);
            JSONObject auth = jsonObj.getJSONObject("cmd");
            boolean success = auth.getBoolean("success");

            if (success) {
                JSONObject params = auth.getJSONObject("params");
                String firstName = params.getString("firstName");
                String lastName = params.getString("lastName");
                Global.name = firstName +" "+ lastName;
            }

        }catch(Exception e){

        }


    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }


}
