package com.ilstechnology.androidkitilsv2;

import android.content.Intent;
import android.os.Handler;
import android.support.v4.widget.SwipeRefreshLayout;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.Toast;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;

public class thing_properties extends AppCompatActivity {

    final JSONParser jSon = new JSONParser();
    int countProp = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.thing_properties);

        final SwipeRefreshLayout swipeView = (SwipeRefreshLayout) findViewById(R.id.swipeProperties);
        swipeView.setColorScheme(android.R.color.holo_blue_dark, android.R.color.holo_blue_light, android.R.color.holo_green_light, android.R.color.holo_orange_light);
        swipeView.setOnRefreshListener(new SwipeRefreshLayout.OnRefreshListener() {
            @Override
            public void onRefresh() {
                swipeView.setRefreshing(true);
                //   Log.d("Swipe", "Refreshing Number");
                (new Handler()).postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        swipeView.setRefreshing(false);
                        apiProps();
                        auxFunction();
                    }
                }, 1000);
            }
        });

        auxFunction();
    }

    private  void auxFunction(){
        ArrayList<SearchResults> searchResults = GetSearchResults();

        final ListView lv1 = (ListView) findViewById(R.id.List_properties);
        lv1.invalidateViews();
        lv1.setAdapter(new MyCustomBaseAdapter(this, searchResults));

        lv1.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> a, View v, int position, long id) {
                Object o = lv1.getItemAtPosition(position);
                SearchResults fullObject = (SearchResults) o;
                Toast.makeText(thing_properties.this, "You have chosen: " + " " + fullObject.getName(), Toast.LENGTH_LONG).show();
            }
        });

    }

    private void apiProps(){

        Thread thread = new Thread(new Runnable(){
            @Override
            public void run() {
                try {
                    //    if (!Global.prevOrg.equals(Global.organizations)){
                    String json = "{\"auth\":{\"sessionId\":\"" + Global.sessionId + "\"},\"cmd\":{\"command\":\"thing.find\",\"params\":{\"key\":\"" + Global.thing_selected + "\"}}}";

                    String response_ = jSon.xHttpPost("http://api.devicewise.com/api", json);
                    System.out.println(json + "------Response Thing-----" + response_);

                    JSONObject jsonObj = new JSONObject(response_);
                    JSONObject auth = jsonObj.getJSONObject("cmd");
                    boolean success = auth.getBoolean("success");
                    if (success) {
                        JSONObject params = auth.getJSONObject("params");

                        thing_details.propName.clear();
                        thing_details.propValue.clear();
                        thing_details.propTs.clear();
                        if(params.has("properties")) {
                            //props
                            JSONObject jsonProps = params.getJSONObject("properties");
                            Iterator<?> keys = jsonProps.keys();
                            while( keys.hasNext() ) {
                                String key = (String)keys.next();
                                JSONObject value = jsonProps.getJSONObject(key);
                                String val = value.getString("value");
                                String ts = value.getString("ts");
                                thing_details.propName.add(key);
                                thing_details.propValue.add("Value: " + val);
                                thing_details.propTs.add(ts);
                                countProp++;
                            }
                        }else{
                            countProp = 0;
                        }
                    }


                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
        thread.start();
        try {
            thread.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    private ArrayList<SearchResults> GetSearchResults(){
        ArrayList<SearchResults> results = new ArrayList<SearchResults>();
        SearchResults sr1;

        for (int i=0; i < thing_details.propName.size(); i++) {
            sr1 = new SearchResults();
            sr1.setName(thing_details.propName.get(i));
            sr1.setValue(thing_details.propValue.get(i));
            sr1.setTs(thing_details.propTs.get(i));
            results.add(sr1);
        }

        return results;
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_thing_properties, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.logout) {
            Global.sessionId = "";
            startActivity(new Intent(thing_properties.this, Main.class));
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
